define("Nexus/usertoken",["Nexus/config","Nexus/messages"],function(){Ext.namespace("Nexus.usertoken");Nexus.usertoken.ID="nx-usertoken";Nexus.usertoken.TITLE="User Token";Nexus.usertoken.showMessage=function(message){Nexus.messages.show(Nexus.usertoken.TITLE,message)};Nexus.usertoken.resourcePath=function(path){if(!path.startsWith("/")){path="/"+path}return Sonatype.config.servicePath+"/usertoken"+path};Nexus.usertoken.iconPath=function(file){if(!file.startsWith("/")){file="/"+file}return Sonatype.config.resourcePath+"/static/icons"+file};Nexus.usertoken.enabled=false;Nexus.usertoken.setEnabled=function(enabled){Nexus.log("Nexus.usertoken.enabled: "+enabled);Nexus.usertoken.enabled=enabled};Sonatype.Events.addListener("nexusStatus",function(){if(Sonatype.user.curr&&Sonatype.user.curr.isLoggedIn){Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/status"),method:"GET",suppressStatus:true,success:function(response){var status=Ext.decode(response.responseText);Nexus.usertoken.setEnabled(status.enabled)},failure:function(){Nexus.usertoken.setEnabled(false)}})}else{Nexus.usertoken.setEnabled(false)}})});
Ext.define("Nexus.usertoken.UserTokenWindow",{extend:"Ext.Window",requires:["Nexus.Image"],requirejs:["Nexus/usertoken"],constructor:function(config){var self=this,exampleXml;Ext.applyIf(config,{message:"You have requested an operation which requires validation of your credentials."});exampleXml="<server>\n  <id>${server}</id>\n  <username>"+config.nameCode+"</username>\n  <password>"+config.passCode+"</password>\n</server>";Ext.apply(self,{cls:"nx-usertoken-UserTokenWindow",title:Nexus.usertoken.TITLE,border:false,closable:true,modal:true,autoHeight:true,width:550,resizable:false,items:[{xtype:"panel",items:[{xtype:"image",cls:"nx-usertoken-icon",src:Nexus.usertoken.iconPath("key-32.png")},{xtype:"label",html:'User tokens are a combination of a name and password codes.<br/><span style="font-weight: bold;">Keep these codes secret!</span><br/><br clear="both"/>Your user token is:<br/><br/>'},{xtype:"textfield",name:"nameCode",width:100,readOnly:true,style:{padding:"2px","font-family":"monospace"},listeners:{render:self.installClickToSelectHandler}},{xtype:"label",html:":",style:{padding:"2px","font-family":"monospace"}},{xtype:"textfield",name:"passCode",width:360,readOnly:true,style:{padding:"2px","font-family":"monospace"},listeners:{render:self.installClickToSelectHandler}},{xtype:"label",html:"<br/><br/>Use the following in your Maven settings.xml:<br/><br/>"},{xtype:"textarea",name:"exampleXml",height:90,width:510,readOnly:true,style:{padding:"2px","font-family":"monospace"},listeners:{render:self.installClickToSelectHandler}},{xtype:"label",html:"<br/><br/>This window will automatically close after one minute."}],buttons:[{text:"Close",scope:self,handler:function(){self.close()}}]}],listeners:{show:function(component){component.find("name","nameCode")[0].setValue(config.nameCode);component.find("name","passCode")[0].setValue(config.passCode);component.find("name","exampleXml")[0].setValue(exampleXml);(function(){if(self.isVisible()){Nexus.usertoken.showMessage("Automatically closing window due to timeout");self.close()}}).defer(1*60*1000)}}});self.constructor.superclass.constructor.apply(self,arguments)},installClickToSelectHandler:function(component){component.getEl().on("click",function(){component.selectText()})}});
Ext.define("Nexus.usertoken.AuthenticateButton",{extend:"Ext.Button",requires:["Nexus.usertoken.AuthenticateWindow"],requirejs:["Nexus/usertoken"],constructor:function(config){var self=this;Ext.apply(self,{cls:"x-btn-text-icon",icon:Nexus.usertoken.iconPath("lock-16.png")});Ext.applyIf(self,{handler:function(){var window=new Nexus.usertoken.AuthenticateWindow({animateTarget:self.getEl(),callback:config.callback});window.show()}});self.constructor.superclass.constructor.apply(self,arguments)}},function(){var type=this;Ext.ComponentMgr.registerType("nx-usertoken-auth-button",type)});
Ext.define("Nexus.usertoken.SettingsView",{extend:"Ext.Panel",requires:["Nexus.usertoken.AuthenticateButton","Nexus.Image","Nexus.CallbackRef"],requirejs:["Nexus/usertoken"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;self.protectContentCheckbox=new Ext.form.Checkbox({name:"protectContent",fieldLabel:"Protect Content",helpText:"Select this option to require that user tokens are used for repository authentication. This does not affect UI access.",disabled:true});self.settingsForm=new Ext.FormPanel({border:false,labelWidth:100,layoutConfig:{labelSeparator:""},items:[{xtype:"checkbox",name:"enabled",fieldLabel:"Enabled",helpText:"Enable user token functionality"},self.protectContentCheckbox],buttons:[{text:"Save",tooltip:"Save settings",formBind:true,scope:self,handler:self.saveSettings},new Nexus.ext.LinkButton({text:"Discard",tooltip:"Discard changes",formBind:false,scope:self,handler:self.discardSettings})]});self.resetPanel=new Ext.form.FieldSet({title:"Reset",autoHeight:true,hidden:true,items:[{xtype:"image",cls:"nx-usertoken-icon",src:Nexus.usertoken.iconPath("error-32.png")},{xtype:"label",html:'Reset will invalidate <span style="font-weight: bold;">ALL</span> existing user tokens and force new tokens to be created the next time accessed.<br/><br clear="both"/>',cls:"nx-usertoken-message"},{xtype:"nx-usertoken-auth-button",text:"Reset All User Tokens",tooltip:"Authenticate and reset all user tokens",callback:{scope:self,fn:self.resetAllUserTokens}}]});Ext.apply(self,{cls:"nx-usertoken-SettingsView",border:false,layout:"vbox",layoutConfig:{align:"stretch"},items:[{xtype:"fieldset",title:"Settings",autoHeight:true,items:[self.settingsForm]},self.resetPanel]});self.constructor.superclass.constructor.apply(self,arguments);self.on("afterlayout",self.loadSettings,self,{single:true})},getWaitMask:function(){var self=this;if(!self.waitMask){self.waitMask=new Ext.LoadMask(self.getEl(),{msg:"Please wait"})}return self.waitMask},setEnabled:function(enabled){Nexus.usertoken.enabled=enabled;this.resetPanel.setVisible(enabled);if(enabled){this.protectContentCheckbox.enable()}else{this.protectContentCheckbox.disable()}this.doLayout()},saveSettings:function(){var self=this,form;self.logDebug("Save settings");self.getWaitMask().show();form=self.settingsForm.getForm();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/settings"),method:"PUT",scope:self,jsonData:{enabled:form.findField("enabled").getValue(),protectContent:form.findField("protectContent").getValue()},callback:function(){self.getWaitMask().hide()},success:function(){Nexus.usertoken.showMessage("Settings saved");self.setEnabled(form.findField("enabled").getValue())}})},loadSettings:function(){var self=this;self.logDebug("Load settings");self.getWaitMask().show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/settings"),method:"GET",scope:self,callback:function(){self.getWaitMask().hide()},success:function(response){var settings=Ext.decode(response.responseText);self.settingsForm.getForm().setValues({enabled:settings.enabled,protectContent:settings.protectContent});self.logDebug("Settings loaded");self.setEnabled(settings.enabled)}})},discardSettings:function(){var self=this;self.logDebug("Discard settings");self.loadSettings()},resetAllUserTokens:function(authTicket){var self=this;self.logDebug("Reset all user tokens");self.getWaitMask().show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/users"),method:"DELETE",scope:self,headers:{"X-NX-UserToken-AuthTicket":authTicket},callback:function(){self.getWaitMask().hide()},success:function(){Nexus.usertoken.showMessage("All user tokens have been reset")}})}},function(){var type=this;Sonatype.Events.addListener("nexusNavigationInit",function(panel){var p=Sonatype.lib.Permissions;if(p.checkPermission("nexus:usertoken:settings",p.READ)){panel.add({enabled:true,sectionId:"st-nexus-security",title:Nexus.usertoken.TITLE,tabId:"usertoken",tabTitle:Nexus.usertoken.TITLE,tabCode:type})}})});
Ext.define("Nexus.usertoken.UserProfileView",{extend:"Ext.Panel",requires:["Nexus.usertoken.AuthenticateButton","Nexus.usertoken.UserTokenWindow","Nexus.Image"],requirejs:["Nexus/usertoken"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;Ext.apply(self,{cls:"nx-usertoken-UserProfileView",border:false,items:[{xtype:"image",cls:"nx-usertoken-icon",src:Nexus.usertoken.iconPath("key-32.png")},{xtype:"label",cls:"nx-usertoken-message",html:'User tokens provide an alternative mechanism to authenticate with Nexus without use of passwords.<br clear="both"/>'},{xtype:"fieldset",title:"Access",autoHeight:true,items:[{xtype:"label",html:'A new user token will be created the first time it is accessed.<br/><br clear="both"/>',cls:"nx-usertoken-message"},{xtype:"nx-usertoken-auth-button",text:"Access User Token",tooltip:"Authenticate and access user token",callback:{scope:self,fn:self.accessUserToken}}]},{xtype:"fieldset",title:"Reset",autoHeight:true,items:[{xtype:"label",html:"Resetting your user token will invalidate the current token and force a new token to be created the next time accessed.<br/><br/>",cls:"nx-usertoken-message"},{xtype:"nx-usertoken-auth-button",text:"Reset User Token",tooltip:"Authenticate and reset user token",callback:{scope:self,fn:self.resetUserToken}}]}]});self.constructor.superclass.constructor.apply(self,arguments)},getWaitMask:function(){var self=this;if(!self.waitMask){self.waitMask=new Ext.LoadMask(self.getEl(),{msg:"Please wait"})}return self.waitMask},accessUserToken:function(authTicket){var self=this;self.logDebug("Access user token");self.getWaitMask().show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/current"),method:"GET",scope:self,headers:{"X-NX-UserToken-AuthTicket":authTicket},callback:function(){self.getWaitMask().hide()},success:function(response){var token,window;token=Ext.decode(response.responseText);window=new Nexus.usertoken.UserTokenWindow({nameCode:token.nameCode,passCode:token.passCode});window.show()}})},resetUserToken:function(authTicket){var self=this;self.logDebug("Reset user token");self.getWaitMask().show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/current"),method:"DELETE",scope:self,headers:{"X-NX-UserToken-AuthTicket":authTicket},callback:function(){self.getWaitMask().hide()},success:function(){Nexus.usertoken.showMessage("Your user token has been reset")}})},shouldShow:function(){var p=Sonatype.lib.Permissions;return Nexus.usertoken.enabled&&p.checkPermission("nexus:usertoken:current",p.CREATE,p.READ,p.DELETE)}},function(){var type=this;Nexus.profile.register(Nexus.usertoken.TITLE,type,["user"])});
Ext.define("Nexus.usertoken.AuthenticateWindow",{extend:"Ext.Window",requires:["Nexus.Image"],requirejs:["Nexus/usertoken"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;Ext.applyIf(config,{message:"You have requested an operation which requires validation of your credentials."});self.callbackRef=new Nexus.CallbackRef(config.callback);self.passwordField=new Ext.form.TextField({fieldLabel:"Password",inputType:"password",name:"password",width:170,allowBlank:false,validateOnBlur:false});Ext.apply(self,{cls:"nx-usertoken-AuthenticateWindow",title:"Authenticate",border:false,closable:false,modal:true,autoHeight:true,width:350,resizable:false,items:[{xtype:"form",autoHeight:true,labelAlign:"right",frame:true,monitorValid:true,layoutConfig:{labelSeparator:""},items:[{xtype:"image",cls:"nx-usertoken-icon",src:Nexus.usertoken.iconPath("lock-32.png")},{xtype:"label",html:config.message+'<br style="clear:both;"/>'},{xtype:"textfield",fieldLabel:"Username",name:"username",width:170,readOnly:true},self.passwordField],buttons:[{text:"Confirm",formBind:true,scope:self,handler:self.doValidate},new Nexus.ext.LinkButton({text:"Cancel",formBind:false,scope:self,handler:self.close})],keys:[{key:Ext.EventObject.ENTER,scope:self,fn:self.doValidate},{key:Ext.EventObject.ESC,scope:self,fn:self.close}]}],listeners:{show:function(component){component.find("name","username")[0].setValue(Nexus.currentUser().username);component.find("name","password")[0].focus(false,100)}}});self.constructor.superclass.constructor.apply(self,arguments)},doValidate:function(){var self=this,mask;mask=new Ext.LoadMask(self.getEl(),{msg:"Authenticating"});mask.show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/authenticate"),method:"POST",suppressStatus:[403],jsonData:{u:Sonatype.utils.base64.encode(Nexus.currentUser().username),p:Sonatype.utils.base64.encode(self.passwordField.getValue())},callback:function(){mask.hide()},success:function(response){self.logDebug("Authenticated");var authTicket=Ext.decode(response.responseText);self.logDebug("Ticket: "+authTicket.t);self.close();self.callbackRef.invoke(authTicket.t)},failure:function(response){if(response.status===403){self.passwordField.markInvalid("Invalid password")}}})}});
Ext.define("Nexus.usertoken.AdminProfileView",{extend:"Ext.Panel",requires:["Nexus.usertoken.AuthenticateButton"],requirejs:["Nexus/usertoken"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;if(!config.username){throw"Missing config.username"}Ext.apply(self,{cls:"nx-usertoken-AdminProfileView",border:false,items:[{xtype:"fieldset",title:"Reset",autoHeight:true,items:[{xtype:"label",html:"Resetting a users token will invalidate the current token and force a new token to be created the next time accessed by the user.<br/><br/>",cls:"nx-usertoken-message"},{xtype:"nx-usertoken-auth-button",text:"Reset User Token",tooltip:"Authenticate and reset this users token",callback:{scope:self,fn:self.resetUserToken}}]}]});self.constructor.superclass.constructor.apply(self,arguments)},getWaitMask:function(){var self=this;if(!self.waitMask){self.waitMask=new Ext.LoadMask(self.getEl(),{msg:"Please wait"})}return self.waitMask},resetUserToken:function(authTicket){var self=this;self.logDebug("Reset user token: "+self.username);self.getWaitMask().show();Ext.Ajax.request({url:Nexus.usertoken.resourcePath("/users/"+self.username),method:"DELETE",headers:{"X-NX-UserToken-AuthTicket":authTicket},callback:function(){self.getWaitMask().hide()},success:function(){Nexus.usertoken.showMessage("User token has been reset for user: "+self.username)}})},shouldShow:function(){var p=Sonatype.lib.Permissions;return Nexus.usertoken.enabled&&p.checkPermission("nexus:usertoken:user",p.READ,p.DELETE)}},function(){var type=this;Nexus.profile.register(Nexus.usertoken.TITLE,type,["admin"])});
define("nexus-usertoken-plugin-boot",["Nexus/usertoken","Nexus/usertoken/SettingsView","Nexus/usertoken/AdminProfileView","Nexus/usertoken/UserProfileView"],function(){Nexus.Log.debug("Usertoken plugin loaded")});
